## mingw-w64-labplot-2.11.1-2.src.tar.zst

=== tests/CMakeLists.txt ===
set(SRC_DIR ${labplot2_SOURCE_DIR}/src)
INCLUDE_DIRECTORIES(${SRC_DIR} ${GSL_INCLUDE_DIR})

# shared code
add_library(labplot2test STATIC CommonTest.cpp analysis/AnalysisTest.cpp nsl/NSLTest.h ../src/backend/lib/Debug.cpp)
target_link_libraries(labplot2test Qt${QT_MAJOR_VERSION}::Test KF${KF_MAJOR_VERSION}::ConfigCore Qt${QT_MAJOR_VERSION}::Widgets KF${KF_MAJOR_VERSION}::I18n)
if (KUserFeedback_FOUND AND QT_MAJOR_VERSION EQUAL 6)
	target_link_libraries( labplot2test KUserFeedbackCoreQt6 KUserFeedbackWidgetsQt6 )
endif ()
target_compile_definitions(labplot2test PUBLIC ${LABPLOT_COMPILE_DEFINITIONS})

add_subdirectory(analysis)
add_subdirectory(backend)
add_subdirectory(cartesianplot)
add_subdirectory(import_export)
add_subdirectory(nsl)
add_subdirectory(spreadsheet)
add_subdirectory(livedata)
add_subdirectory(matrix)
add_subdirectory(multirange)
add_subdirectory(commonfrontend)

IF (Cantor_FOUND)
    add_subdirectory(notebook)
ENDIF ()


option(ENABLE_TEST_DEPENDENCIES "Enable Dependencies Tests" ON)
if (ENABLE_TEST_DEPENDENCIES)
    add_executable (DependenciesTest DependenciesTest.cpp)
    target_link_libraries(DependenciesTest labplot2test labplot2lib)
    add_test(NAME DependenciesTest COMMAND DependenciesTest)
endif()

=== tests/livedata/CMakeLists.txt ===
add_executable (LiveDataTest LiveDataTest.cpp)

target_link_libraries(LiveDataTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)

add_test(NAME LiveDataTest COMMAND LiveDataTest)

=== tests/spreadsheet/CMakeLists.txt ===
option(ENABLE_TEST_SPREADSHEET "Enable Spreadsheet Tests" ON)

if (ENABLE_TEST_SPREADSHEET)

    add_executable (SpreadsheetTest SpreadsheetTest.cpp)
    target_link_libraries(SpreadsheetTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)
    add_test(NAME SpreadsheetTest COMMAND SpreadsheetTest)

    add_executable (SpreadsheetFormulaTest SpreadsheetFormulaTest.cpp)
    target_link_libraries(SpreadsheetFormulaTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)
    add_test(NAME SpreadsheetFormulaTest COMMAND SpreadsheetFormulaTest)

    add_executable (SpreadsheetGenerateDataTest SpreadsheetGenerateDataTest.cpp)
    target_link_libraries(SpreadsheetGenerateDataTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)
    add_test(NAME SpreadsheetGenerateDataTest COMMAND SpreadsheetGenerateDataTest)

endif()

=== data/pics/gsl_distributions/CMakeLists.txt ===
FILE(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.pdf")
if (APPLE)
	install(FILES ${files} DESTINATION ${KDE_INSTALL_DATADIR}/pics/gsl_distributions )
else ()
	install(FILES ${files} DESTINATION ${KDE_INSTALL_DATADIR}/${PROJECT_NAME}/pics/gsl_distributions )
endif ()

=== tests/analysis/correlation/CMakeLists.txt ===
add_executable (CorrelationTest CorrelationTest.cpp)

target_link_libraries(CorrelationTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)

add_test(NAME CorrelationTest COMMAND CorrelationTest)

=== tests/analysis/fit/CMakeLists.txt ===
add_executable (FitTest FitTest.cpp)

target_link_libraries(FitTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)

add_test(NAME FitTest COMMAND FitTest)

=== tests/import_export/CAN/CMakeLists.txt ===
option(ENABLE_TEST_IMPORTEXPORT_CAN "Enable CAN Bus related Tests" ON)

if (ENABLE_TEST_IMPORTEXPORT_CAN)
    add_executable (BLFFilterTest BLFFilterTest.cpp)

    target_link_libraries(BLFFilterTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)
    add_test(NAME BLFFilterTest COMMAND BLFFilterTest)
endif()

=== tests/import_export/Datasets/CMakeLists.txt ===
option(ENABLE_TEST_IMPORTEXPORT_DATASET "Enable Dataset Tests" ON)

if (ENABLE_TEST_IMPORTEXPORT_DATASET)

    add_executable (DatasetsTest DatasetsTest.cpp)

    # TODO: inherit from general test and remove labplot2backendlib, labplot2nsllib
    target_link_libraries(DatasetsTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)

    add_test(NAME DatasetsTest COMMAND DatasetsTest)

endif()

=== tests/import_export/ReadStat/CMakeLists.txt ===
add_executable (ReadStatFilterTest ReadStatFilterTest.cpp)

target_link_libraries(ReadStatFilterTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)

add_test(NAME ReadStatFilterTest COMMAND ReadStatFilterTest)

=== tests/import_export/Spice/CMakeLists.txt ===
option(ENABLE_TEST_IMPORTEXPORT_SPICE "Enable Spice Tests" ON)

if (ENABLE_TEST_IMPORTEXPORT_SPICE)

add_executable (SpiceFilterTest SpiceFilterTest.cpp)
target_compile_definitions(SpiceFilterTest PRIVATE SPICEFILTERTEST_EN)

target_link_libraries(SpiceFilterTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)
target_compile_definitions(labplot2backendlib PRIVATE SPICEFILTERTEST_EN)

add_test(NAME SpiceFilterTest COMMAND SpiceFilterTest)

endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=labplot
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.11.1
pkgrel=2
pkgdesc="FREE, open source and cross-platform Data Visualization and Analysis software accessible to everyone. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://labplot.org'
msys2_repository_url="https://invent.kde.org/education/labplot"
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-breeze"
         "${MINGW_PACKAGE_PREFIX}-cfitsio"
         "${MINGW_PACKAGE_PREFIX}-dbc_parser_cpp"
         "${MINGW_PACKAGE_PREFIX}-discount"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-gsl"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-ixion"
         "${MINGW_PACKAGE_PREFIX}-karchive"
         "${MINGW_PACKAGE_PREFIX}-kcompletion"
         "${MINGW_PACKAGE_PREFIX}-kconfig"
         "${MINGW_PACKAGE_PREFIX}-kconfigwidgets"
         "${MINGW_PACKAGE_PREFIX}-kcoreaddons"
         "${MINGW_PACKAGE_PREFIX}-kcrash"
         "${MINGW_PACKAGE_PREFIX}-ki18n"
         "${MINGW_PACKAGE_PREFIX}-kiconthemes"
         "${MINGW_PACKAGE_PREFIX}-kio"
         "${MINGW_PACKAGE_PREFIX}-kparts"
         "${MINGW_PACKAGE_PREFIX}-kservice"
         "${MINGW_PACKAGE_PREFIX}-ktextwidgets"
         "${MINGW_PACKAGE_PREFIX}-kuserfeedback"
         "${MINGW_PACKAGE_PREFIX}-kwidgetsaddons"
         "${MINGW_PACKAGE_PREFIX}-kxmlgui"
         "${MINGW_PACKAGE_PREFIX}-libcerf"
         "${MINGW_PACKAGE_PREFIX}-liborigin"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-matio"
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-orcus"
         "${MINGW_PACKAGE_PREFIX}-poppler-qt6"
         "${MINGW_PACKAGE_PREFIX}-purpose"
         "${MINGW_PACKAGE_PREFIX}-qt-advanced-docking-system"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-mqtt"
         "${MINGW_PACKAGE_PREFIX}-qt6-serialport"
         "${MINGW_PACKAGE_PREFIX}-qt6-svg"
         "${MINGW_PACKAGE_PREFIX}-qxlsx"
         "${MINGW_PACKAGE_PREFIX}-readstat"
         "${MINGW_PACKAGE_PREFIX}-syntax-highlighting"
         "${MINGW_PACKAGE_PREFIX}-vector_blf"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-gettext-tools"
             "${MINGW_PACKAGE_PREFIX}-icoutils"
             "${MINGW_PACKAGE_PREFIX}-extra-cmake-modules"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-kdoctools"
             "${MINGW_PACKAGE_PREFIX}-knewstuff"
             "${MINGW_PACKAGE_PREFIX}-shared-mime-info")
source=("https://download.kde.org/stable/labplot/labplot-${pkgver}.tar.xz"
        "001-some-qt6-fixes.patch::https://invent.kde.org/education/labplot/-/commit/0edfd286.patch"
        "002-fix-build-with-kuserfeedback.patch"
        "003-fix-build-with-qxlsx.patch"
        "004-fix-find-poppler-qt6.patch"
        "005-fix-find-qtadvanceddocking.patch"
        "006-fix-build-with-ixion-0.20.patch")
sha256sums=('53aa6ac8df39324d99463e60d88de25346b3928da5bb0f210b0563489046679d'
            '998d361b026aa5db9153c73ca930a1843098d8ba4b7b357b1508a6361bb3aa51'
            '345dbe2802d2acf146ced5030314ad59dcae7c415bafd48698a3503999751974'
            '1525d4be3aa7c9136e4487b51b56bb0cd81cb64e0ebe54942183d3685d1ff664'
            '9d390317042c80740e0fd3b7274eb4ed8e1c50a34eafe51844f8e72351d7f117'
            'a9ad822875ead147e7e2193393b5fe3100dcd8e50b0e89017eadc2b78c8ba5e3'
            'a82756ed1a76570c9176aef3e3195e83aaef48b1697c942248c5d7f593d1dad7')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd ${_realname}-${pkgver}

  apply_patch_with_msg \
    001-some-qt6-fixes.patch \
    002-fix-build-with-kuserfeedback.patch \
    003-fix-build-with-qxlsx.patch \
    004-fix-find-poppler-qt6.patch \
    005-fix-find-qtadvanceddocking.patch \
    006-fix-build-with-ixion-0.20.patch

  # remove conflict with breeze package
  rm data/color-schemes/BreezeDark.colors

  # clang picked it as <format> header file
  rm src/3rdparty/liborigin/FORMAT
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DENABLE_ORCUS=ON \
      -DENABLE_TESTS=OFF \
      -DENABLE_SDK=OFF \
      -DLOCAL_DBC_PARSER=OFF \
      -DLOCAL_VECTOR_BLF=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSES/* \
    -t "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/
}
